// David Pilling March 2017


#include <stdarg.h>

void pr(char *fmt, ... )
{

  
  char buf[128]; // resulting string limited to 128 chars
  va_list args;
  va_start (args, fmt );
  vsnprintf(buf, 128, fmt, args);
  va_end (args);
  Serial.println(buf);
}





void setup_serial(void)
{


}


void setup () 
{
 Serial.begin(9600);

 ADCSRA=0; // ADC Control and Status Register A

 ADCSRB=(1<<ACME); // enable muliplxer
 ADMUX=0; // ADC Multiplexer Selection Register
 ACSR=(1<<ACBG); // Analog Comparator Bandgap Select
}


#define TIMEOUT 90
#define MUXWAIT 16


void loop () 
{
 unsigned long looptime;
 int shift;
 int val;
 int oldval;
 int inches;
 int negative;
 int outputval;
  
 while(1)
 {
  if(shift>=24)
  {
   pr("value %d %s",(negative?-outputval:outputval)/(inches?2:1),inches?"in":"mm");
  }

  looptime=millis();
  outputval=0;
  inches=0;
  negative=0;
  shift=0;

  while(1)
  {
   ADMUX=0;
   __builtin_avr_delay_cycles(MUXWAIT);
   val=(ACSR & (1<<ACO));
   while(1)
   {
    oldval=val;
    val=(ACSR & (1<<ACO));
    if(!val && oldval) break;
    if((millis()-looptime)>TIMEOUT) break;
   }

   if((millis()-looptime)>TIMEOUT) break;

    ADMUX=1;
   __builtin_avr_delay_cycles(MUXWAIT);
   val=(ACSR & (1<<ACO));
   if(!val)
   {
    if(shift<12) outputval|=(1<<shift);
    if(shift==23) inches=true;
    if(shift==20) negative=true;
   }
   shift++;
   if(shift>=24) break;
  }
 }
}





